# -*- coding: UTF-8 -*-

import sys

if sys.version_info.major == 3:
    from abc import ABC, abstractmethod
else:
    from abc import ABCMeta as ABC, abstractmethod

from common import logger

"""
Базовый класс для конвертеров - некий задел на будущее
по-хорошему, нужно что-то вроде фабрики для создания инстанса конвертера по имени
"""
class Converter(object):
    __metaclass__ = ABC

    commands = dict()

    def __init__(self, node):
        self.work_dir = None
        self.log = logger.getUploadLogger("Node", node.id)
        self.inserter = getattr(__import__('upload.inserter.%s' % node.inserter.name, fromlist='Inserter'), 'Inserter')(
            node)
        self.objects = None
        self.errorObjectsCount = 0
        self.shopcode = node.shopCode


    def general_method(self, work_dir, data):
        self.work_dir = work_dir
        self.parse(data)

    @abstractmethod
    def parse(self, data):
        self.log.debug("Parsing data from file...")

    def load_objects(self, objects, size):
        """
        Добавление объектов в inserter
        objects - список объектов, которые нужно загрузить,
        size - порог срабатывания загрузки
        """
        self.objects.extend(objects)
        if len(self.objects) >= size:
            self.inserter.add_package(self.objects)
            self.objects = []  # объекты загружены - очищаем список