# -*- coding: UTF-8 -*-

import os
from common import config, filesmodify, logger
from upload.inserter import InserterError

errorObjectsCount = 0


def invalidObjectsCount():
    return errorObjectsCount


def general_method(workDirectory, data, node):
    global errorObjectsCount
    log = logger.getUploadLogger("Node", node.id)
    errorList = []
    users = {}
    for roleCode in config.getOptions('upload.converter.users.roles'):
        users[config.getString('upload.converter.users.roles', roleCode, 'название роли')] = roleCode

    try:
        plugin = __import__('upload.inserter.%s' % node.inserter.name, fromlist='Inserter')
        cl = getattr(plugin, 'Inserter')
        inserter = cl(node)
        listObjects = []
        result = inserter.start()
        if result:
            for filename in data:
                f = open(filename)
                listObjects.append({'command': 'clearMCashUser'})
    
                line = f.readline()
                while line:
                    lineWords = line.decode('866').encode('utf8').split(",")
                    if len(lineWords) > 3:
                        login = ''
                        password = ''
                        
                        if lineWords[0][0] == ";":
                            login = lineWords[0][1:]
                            login = "00000000"[:-len(login)] + login
                            password = lineWords[0][0:1] + login + "=" + lineWords[1]
                        else:
                            login = lineWords[0]
                            login = "00000000"[:-len(login)] + login
                            password = lineWords[1]    
                    
                        user = lineWords[2]
                        roleid = 0
                        name = lineWords[3]
                        
                        if user in users:
                            roleid = users[user]
                            obj = {
                                'command': 'addMCashUser',
                                'mcashuser': {
                                    'code': login,
                                    'login': login,
                                    'name': name,
                                    'password': password,
                                    'roleusers': [{'rolecode': roleid, 'rule': '1'}]
                                }
                            }
                            listObjects.append(obj)
                            if len(listObjects) >= node.pack_size:
                                inserter.add_package(listObjects)
                                del listObjects[:]
                    line = f.readline()
                if len(listObjects) > 0:
                    inserter.add_package(listObjects)
                    del listObjects[:]
                f.close()
            result = inserter.stop()
            errorObjectsCount = inserter.invalidObjectsCount()
        return result, errorList
    except InserterError as e:
        raise
    except Exception as e:
        log.error(u'Ошибка: ' + str(e))
        errorList.append(u'Ошибка: ' + str(e))
    return False, errorList


def convert(workDirectory, node):
    workDirectory = os.path.normpath(workDirectory + '/' + node.id + '/' + node.currentConverter)
    if not os.path.exists(workDirectory):
        os.makedirs(workDirectory)
    filesmodify.moveFiles(node.currentConverter.flags, workDirectory)
    data = filesmodify.moveFiles(node.currentConverter.data, workDirectory)
    result = general_method(workDirectory, data, node)
    return result

